use swc_ecma_ast::Module;
use swc_ecma_codegen::Config;
// use swc_ecma_codegen::{text_writer::JsWriter, Config, Emitter};
// use swc_common::{sync::Lrc, SourceMap};
use thiserror::Error;

#[derive(Error, Debug)]
pub enum EmitError {
    #[error("Failed to emit JavaScript: {0}")]
    EmitFailed(String),
}

pub struct JsEmitter {
    config: Config,
}

impl JsEmitter {
    pub fn new() -> Self {
        Self {
            config: Config::default(),
        }
    }

    pub fn with_minify(mut self) -> Self {
        self.config.minify = true;
        self
    }

    pub fn emit(&self, _module: Module) -> Result<String, EmitError> {
        // SWC codegen here
        return Err(EmitError::EmitFailed(
            "Emitter not yet implemented!".to_owned(),
        ));
    }
}
